GNU bug report logs - #24672
26.0.50; viper-mode + c-mode: "ce" fails in cpp-continued stmt

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Jim Meyering <jim@HIDDEN>; dated Wed, 12 Oct 2016 04:00:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 24672 <at> debbugs.gnu.org:


Received: (at 24672) by debbugs.gnu.org; 26 Oct 2016 15:37:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 26 11:37:55 2016
Received: from localhost ([127.0.0.1]:57728 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bzQH4-00046b-QZ
	for submit <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:37:55 -0400
Received: from mail-it0-f51.google.com ([209.85.214.51]:37318)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1bzQH3-00046O-By
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:37:53 -0400
Received: by mail-it0-f51.google.com with SMTP id u205so40191832itc.0
 for <24672 <at> debbugs.gnu.org>; Wed, 26 Oct 2016 08:37:53 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:in-reply-to:references:from:date:message-id
 :subject:to:cc;
 bh=Pc712CYV+l6SMd/Ypq8lcwpMl2UtibU0Dl1WATmAug4=;
 b=ipk6xDaqwpCQ81wsaeWaD3ak0IPq4sUUEZD6U32jqLvg2+rIkdRbi1Zin0/f+U08pl
 qij1GDGLsj4mzr5lj46viFDNguQB/9NvJr3pBCUkyJ8QVQfwtpvhocUmkCv6oeHuBWm2
 CikYzqCtDzDvR6TqF1HL8Qm3Cwur/lqz7DjCb+bfMD4nXil9XRyqtfiroCCGh85gnjMK
 l4OMY3iMy8k3gYE1Q8m+9BDTCcojxdUplRrL1QKhTOLJ7bZ0jz+4ZNR/uaMjrAxdLwNc
 5lXFbRD/WujKaiKIOuuI/ayPxDat6nLVurMAyZdyqrBh67lTW5um5ov1thZrGqc2QBlw
 4k0Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:mime-version:sender:in-reply-to:references:from
 :date:message-id:subject:to:cc;
 bh=Pc712CYV+l6SMd/Ypq8lcwpMl2UtibU0Dl1WATmAug4=;
 b=JPth17Mp1JilSutIyJEZNpJaq0apuBNIZplK4rRhvQ7HTztGrA175mggPx7d+q9yT0
 8zPoPiEgEobOsf/9JAzSMeGyPVX3Bdgw2rJvkDmfnROy5UiPsY4gpazo9RMvRY0ijIJA
 ucMJg7bDlBz3cT86uO/eDIMXwLnevlz0P6VI7NA9m6bFfn0qxktE/68TeyS4zDtEq0+Y
 jRazekVLLPhJCSPD1eixBWDfaNySa2sNSy7R++3/hAFYbtwVuF1RmDhdmr9lZQcAdDC7
 naa034SDLPxnqAhRptvPJRxkcu2WYD6sqZTm+BEfOVRGV2/4kab6YffaNOP1DKxu5Jdy
 etRg==
X-Gm-Message-State: ABUngvcjywG0caw4oC50waOcKzumpe/3A+/JGvHxJGhK/57Px+6E9UOBPepSbBk/W7LLlzXzh3NoZKozhtf0yw==
X-Received: by 10.36.85.9 with SMTP id e9mr3114482itb.31.1477496267688; Wed,
 26 Oct 2016 08:37:47 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.107.174.21 with HTTP; Wed, 26 Oct 2016 08:37:26 -0700 (PDT)
In-Reply-To: <831sz3up7q.fsf@HIDDEN>
References: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
 <831sz3up7q.fsf@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Wed, 26 Oct 2016 08:37:26 -0700
X-Google-Sender-Auth: n1spxup5oAOZbOduQ4eteqGxGM0
Message-ID: <CA+8g5KFuYDnWT4BzJtEZKYC2Ntc83ehP19r-1fsjsbswtmm=gg@HIDDEN>
Subject: Re: writing a test for Bug#24672 (viper mode malfunction while
 inserting a paren in continued cpp directive)
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 24672
Cc: 24672 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

On Wed, Oct 26, 2016 at 8:03 AM, Eli Zaretskii <eliz@HIDDEN> wrote:
>> From: Jim Meyering <jim@HIDDEN>
>> Date: Tue, 25 Oct 2016 22:09:40 -0700
>>
>> +(ert-deftest viper-test-insert-paren-on-cpp-continued-line()
>> +  "Test for bug #24672:
>> +Insert '#define z_b\', then change the 'z' to a parenthesis (open or closed)"
>> +  (should
>> +   (equal
>> +    "#define (_b\\\n"
>> +    (viper-test-undo-kmacro
>> +     [
>> +      ?i ?# ?d ?e ?f ?i ?n ?e ?  ?z ?_ ?b ?\\ escape
>> +         ?F ?z ?s ?\( escape
>> +         ])
>> +    )))
>> +
>
> Is there a reason why the test uses 'F', but the recipe you posted
> uses 'f' (lower-case)?  (I know nothing about vi commands.)

The test case constructs it "live", so after inserting the text into
the buffer, point is at the end of the line. From there, "Fz" (search
backwards for "z") is appropriate. My command-line example opens a
file with that contents already there, and with point at the beginning
of the line, so there I used "fz" search forwards for "z").




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24672; Package emacs. Full text available.

Message received at 24672 <at> debbugs.gnu.org:


Received: (at 24672) by debbugs.gnu.org; 26 Oct 2016 15:04:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 26 11:04:08 2016
Received: from localhost ([127.0.0.1]:57708 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bzPkM-0003EH-1K
	for submit <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:04:08 -0400
Received: from eggs.gnu.org ([208.118.235.92]:51147)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1bzPkH-0003Dd-00
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:04:04 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1bzPk7-0005wd-Se
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:03:56 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.4 required=5.0 tests=BAYES_20,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:37294)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1bzPk7-0005wW-PD; Wed, 26 Oct 2016 11:03:51 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2457
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1bzPk7-000753-7T; Wed, 26 Oct 2016 11:03:51 -0400
Date: Wed, 26 Oct 2016 18:03:53 +0300
Message-Id: <831sz3up7q.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Jim Meyering <jim@HIDDEN>
In-reply-to: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
 (message from Jim Meyering on Tue, 25 Oct 2016 22:09:40 -0700)
Subject: Re: writing a test for Bug#24672 (viper mode malfunction while
 inserting a paren in continued cpp directive)
References: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 24672
Cc: 24672 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

> From: Jim Meyering <jim@HIDDEN>
> Date: Tue, 25 Oct 2016 22:09:40 -0700
> 
> +(ert-deftest viper-test-insert-paren-on-cpp-continued-line()
> +  "Test for bug #24672:
> +Insert '#define z_b\', then change the 'z' to a parenthesis (open or closed)"
> +  (should
> +   (equal
> +    "#define (_b\\\n"
> +    (viper-test-undo-kmacro
> +     [
> +      ?i ?# ?d ?e ?f ?i ?n ?e ?  ?z ?_ ?b ?\\ escape
> +         ?F ?z ?s ?\( escape
> +         ])
> +    )))
> +

Is there a reason why the test uses 'F', but the recipe you posted
uses 'f' (lower-case)?  (I know nothing about vi commands.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24672; Package emacs. Full text available.

Message received at 24672 <at> debbugs.gnu.org:


Received: (at 24672) by debbugs.gnu.org; 26 Oct 2016 15:03:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 26 11:03:03 2016
Received: from localhost ([127.0.0.1]:57704 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bzPjH-0003CJ-Uc
	for submit <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:03:03 -0400
Received: from eggs.gnu.org ([208.118.235.92]:50695)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1bzPjC-0003C2-KW
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:02:58 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1bzPj2-0005Gz-TJ
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 11:02:49 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.4 required=5.0 tests=BAYES_40,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:37277)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1bzPj2-0005Gn-Pu; Wed, 26 Oct 2016 11:02:44 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2453
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1bzPj2-0004cn-4U; Wed, 26 Oct 2016 11:02:44 -0400
Date: Wed, 26 Oct 2016 18:02:45 +0300
Message-Id: <8337jjup9m.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Jim Meyering <jim@HIDDEN>
In-reply-to: <CA+8g5KFJn2Zcb+GoiF=uuagASNFSYTKV2P2KNKjtk460wuAftg@HIDDEN>
 (message from Jim Meyering on Wed, 26 Oct 2016 07:33:23 -0700)
Subject: Re: writing a test for Bug#24672 (viper mode malfunction while
 inserting a paren in continued cpp directive)
References: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
 <83insfuy45.fsf@HIDDEN>
 <CA+8g5KFJn2Zcb+GoiF=uuagASNFSYTKV2P2KNKjtk460wuAftg@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 24672
Cc: 24672 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

> From: Jim Meyering <jim@HIDDEN>
> Date: Wed, 26 Oct 2016 07:33:23 -0700
> Cc: 24672 <at> debbugs.gnu.org
> 
> I can see how the insertion of those TABs may be expected,
> but the original bug that caught my eye is that the "z" I wanted
> to replace is *not* removed.

Well, your bug report never said that this was the problem, so how
could I have guessed that?  Do you expect me to know the vi commands
by heart? ;-)





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24672; Package emacs. Full text available.

Message received at 24672 <at> debbugs.gnu.org:


Received: (at 24672) by debbugs.gnu.org; 26 Oct 2016 14:34:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 26 10:34:48 2016
Received: from localhost ([127.0.0.1]:57670 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bzPHw-0002XL-GL
	for submit <at> debbugs.gnu.org; Wed, 26 Oct 2016 10:34:48 -0400
Received: from mail-it0-f45.google.com ([209.85.214.45]:34988)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1bzPHr-0002X5-0z
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 10:34:43 -0400
Received: by mail-it0-f45.google.com with SMTP id e187so26758971itc.0
 for <24672 <at> debbugs.gnu.org>; Wed, 26 Oct 2016 07:34:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:in-reply-to:references:from:date:message-id
 :subject:to:cc;
 bh=hyTjFU4dNKTY7rqgnSsdnhla1W7WfQyAjB6nIJKRpeA=;
 b=0fQffB0HVhQUanMZaKDqxQnFmt4WYwcjESC73JFNoikwc6ew+X7nNAleeAzwHbQnKZ
 9wIg6ZQldVOn9gEOX1Iy+NNBTy7E+BaXLe1NbCCWD+JQc2ZMX/JXN5VpsySWCXU05BUs
 DcUhpUw1oUbUZU1OUjB4gjE1Mz6zOclujOWITVyyOwSKRpPj1eAuaJ45ErlybUXdlhXz
 2GTWvu3T5jOBatYkCXl9SGsqEPjzBBYmpMrwJuEQBel8EiDYclYUt2PgkA46RCJDIiO3
 UWTLdFkzP3bM8TVd/lrLRJYdP9+jDZg9mDPXOg91lOaI/eFhMIf8Hc+EWpvPggMAv0c/
 y4hw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:mime-version:sender:in-reply-to:references:from
 :date:message-id:subject:to:cc;
 bh=hyTjFU4dNKTY7rqgnSsdnhla1W7WfQyAjB6nIJKRpeA=;
 b=TKJgXW2hKVNKUn3R97l0rnFuIEzeFe1QMyjK5iWDmieHArsgzMG1Qc4p/GihWE/PwN
 o0Q0zbs85Lp5cNMZzYMzZTfoTm7uQwKU+zxTdxXQuYJ+eJt7PQOry+hQ0cKIsjdEpInC
 v5wO3dCoCpD/LtHTj1LshoX30vIc5tqBsw7f2kehqvAEm0adHy1sBkRMRSpeeKI8M8pj
 /9+LBylwQcqRYHQGKoSaA3tcQD2locYLHmSid3ddT3oqy4mGp0OqlcZWYneiqKX3Sc88
 OAHbwrhSoNTtKOaegEnutcov19kQ0NqLnjIUbGUDCiS7Ri3Z3uRB+Fvgc7mK83M8rX31
 BuBQ==
X-Gm-Message-State: ABUngvdGtjPt/swcZ85kjwFLm+S1+mkFLi0/u5hZTYaLM2Y+xRv+EPIhGTXq/FO1p3j6M0HEmxXLwidv55BvCw==
X-Received: by 10.36.92.14 with SMTP id q14mr2730930itb.97.1477492423757; Wed,
 26 Oct 2016 07:33:43 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.107.174.21 with HTTP; Wed, 26 Oct 2016 07:33:23 -0700 (PDT)
In-Reply-To: <83insfuy45.fsf@HIDDEN>
References: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
 <83insfuy45.fsf@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Wed, 26 Oct 2016 07:33:23 -0700
X-Google-Sender-Auth: WAq_ti8yqVf6TAxL7mhh4ASFoFE
Message-ID: <CA+8g5KFJn2Zcb+GoiF=uuagASNFSYTKV2P2KNKjtk460wuAftg@HIDDEN>
Subject: Re: writing a test for Bug#24672 (viper mode malfunction while
 inserting a paren in continued cpp directive)
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 24672
Cc: 24672 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On Wed, Oct 26, 2016 at 4:51 AM, Eli Zaretskii <eliz@HIDDEN> wrote:
>> From: Jim Meyering <jim@HIDDEN>
>> Date: Tue, 25 Oct 2016 22:09:40 -0700
>>
>> This is a corner case.
>> When I start in viper mode with this file contents:
>>
>>   #define z_b\
>>
>> and then change the "z" to a parenthesis (either one), I get this:
>>
>>   #define (z_b^I^I^I^I^I\$
>>
>> [I have represented each TAB as "^I", of course]
>> Rather surprising to see all of those TAB characters inserted.
>
> This is standard operation of the Emacs C mode: some characters,
> including the left parenthesis, are "electric", in that they invoke
> reindentation/reformatting of the current line.  Type "C-h k (" to see
> the documentation of that, including links to customization options,
> which you can tweak if you don't like the default behavior.
>
> IOW, I don't think this is a bug at all, but intended behavior.

Thanks for replying.
I can see how the insertion of those TABs may be expected,
but the original bug that caught my eye is that the "z" I wanted
to replace is *not* removed.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24672; Package emacs. Full text available.

Message received at 24672 <at> debbugs.gnu.org:


Received: (at 24672) by debbugs.gnu.org; 26 Oct 2016 11:51:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 26 07:51:54 2016
Received: from localhost ([127.0.0.1]:57062 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bzMkJ-00077o-Ss
	for submit <at> debbugs.gnu.org; Wed, 26 Oct 2016 07:51:54 -0400
Received: from eggs.gnu.org ([208.118.235.92]:53097)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1bzMkF-00077Z-J0
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 07:51:51 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1bzMk5-0007T7-Qg
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 07:51:42 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.6 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:33194)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1bzMk5-0007T1-Mo; Wed, 26 Oct 2016 07:51:37 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2055
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1bzMk5-00046U-32; Wed, 26 Oct 2016 07:51:37 -0400
Date: Wed, 26 Oct 2016 14:51:38 +0300
Message-Id: <83insfuy45.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Jim Meyering <jim@HIDDEN>
In-reply-to: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
 (message from Jim Meyering on Tue, 25 Oct 2016 22:09:40 -0700)
Subject: Re: writing a test for Bug#24672 (viper mode malfunction while
 inserting a paren in continued cpp directive)
References: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 24672
Cc: 24672 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

> From: Jim Meyering <jim@HIDDEN>
> Date: Tue, 25 Oct 2016 22:09:40 -0700
> 
> This is a corner case.
> When I start in viper mode with this file contents:
> 
>   #define z_b\
> 
> and then change the "z" to a parenthesis (either one), I get this:
> 
>   #define (z_b^I^I^I^I^I\$
> 
> [I have represented each TAB as "^I", of course]
> Rather surprising to see all of those TAB characters inserted.

This is standard operation of the Emacs C mode: some characters,
including the left parenthesis, are "electric", in that they invoke
reindentation/reformatting of the current line.  Type "C-h k (" to see
the documentation of that, including links to customization options,
which you can tweak if you don't like the default behavior.

IOW, I don't think this is a bug at all, but intended behavior.

Thanks.

P.S. Please don't cross-post to emacs-devel and the bug list.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24672; Package emacs. Full text available.

Message received at 24672 <at> debbugs.gnu.org:


Received: (at 24672) by debbugs.gnu.org; 26 Oct 2016 05:10:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 26 01:10:08 2016
Received: from localhost ([127.0.0.1]:56913 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bzGTY-0004aK-0Z
	for submit <at> debbugs.gnu.org; Wed, 26 Oct 2016 01:10:08 -0400
Received: from mail-it0-f67.google.com ([209.85.214.67]:32941)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1bzGTW-0004Zo-EH
 for 24672 <at> debbugs.gnu.org; Wed, 26 Oct 2016 01:10:06 -0400
Received: by mail-it0-f67.google.com with SMTP id e187so205425itc.0
 for <24672 <at> debbugs.gnu.org>; Tue, 25 Oct 2016 22:10:06 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:from:date:message-id:subject:to;
 bh=eBx8JsoaJVlyG0rxSAfigMaGNAvtuLT/6018hbM0+DE=;
 b=mYGjfGdzGKKlvPTkYizZffCk718jpdxFyPs/Mr/qXz8gvElQL0j8uQ8NEsHqEWYfdN
 ze86bH5gK/YdHDHFZYmUbtTG2/a7UTN3aaqsK6y+YvcXkA/LbFaG4GjzvIpVk/eTJ1Ke
 5qYgbotlbThAGkGKSvwPqWqrqx4uBKIIWVFvSZRTLSLQlNpljakrCVmvr71TySiDxo4f
 qKAKgR/TtlT+kbYvLi46VvgQE91+FgKf7NuUYTqEGQG59bGxmmVrIWnKDvvCulETmSpU
 elFnTrC+31RZf+boi8RqPUrbLHH430wZhKYlWS92wWkmi+niWe57iEJV4P1GgyjsGLof
 MUbg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:mime-version:sender:from:date:message-id:subject
 :to; bh=eBx8JsoaJVlyG0rxSAfigMaGNAvtuLT/6018hbM0+DE=;
 b=QA9tUtni8STuoojZvYWhLvj3JalWzt4GHY7EAfgZkXRQKnNc7CX+3g5Mv8APgumeHG
 mmjBB9Do2C3yLFMXYJcIbf5zGNs08Md+dM9ffrKdPII2JenQ++Z8R2nevG9LzAvr812C
 LhyDdZcwgUnnJbdpxXpm4WBwNBCIV5/4joxxftyYEz/7UNWapaACXiXxnbSSEGNbU6Sc
 zjQKft8c9P1Z9ZylfPsxQIhcTe4Mk6p19UlzpZwjZziXviKB1w+vd50NZdOtQOFJOL6s
 E9C1KB3YYzqicDYD6o6BhEADtGfPVnjd8Sopc2xRKiwILaMVWhdj07d1nEUQBqP8LT28
 tscA==
X-Gm-Message-State: ABUngveOyA9rqBckwuD3xrvJD1zwegVb3laefDWTK3CqGYQm6yrCk3my8ywUOi73jgfiHPqI2Xsv6/iV9k6XzA==
X-Received: by 10.107.132.88 with SMTP id g85mr659124iod.29.1477458600811;
 Tue, 25 Oct 2016 22:10:00 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.107.174.21 with HTTP; Tue, 25 Oct 2016 22:09:40 -0700 (PDT)
From: Jim Meyering <jim@HIDDEN>
Date: Tue, 25 Oct 2016 22:09:40 -0700
X-Google-Sender-Auth: xPK-SpbdaWBUDLhqwyyZXIScQSI
Message-ID: <CA+8g5KGMrDHWQywkP-OsZoEVEVreWHTOwajFjVeB4ugeu-6pog@HIDDEN>
Subject: writing a test for Bug#24672 (viper mode malfunction while inserting
 a paren in continued cpp directive)
To: emacs-devel <emacs-devel@HIDDEN>, 24672 <at> debbugs.gnu.org
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: 0.7 (/)
X-Debbugs-Envelope-To: 24672
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.7 (/)

This is a corner case.
When I start in viper mode with this file contents:

  #define z_b\

and then change the "z" to a parenthesis (either one), I get this:

  #define (z_b^I^I^I^I^I\$

[I have represented each TAB as "^I", of course]
Rather surprising to see all of those TAB characters inserted. To
reproduce, run this:

  mkdir ~/empty && printf '#define z_b\\\n' > k.c \
    && HOME=$HOME/empty /bin/emacs -Q -f viper-mode k.c

hit "n", "n", and "5" at the successive prompts, then e.g., "fzs(" to
perform the change and to see the surprising result.

I tried to write a test case to encapsulate the above, but so far have
failed, because when run via the test, viper-mode does what one would
expect.

commit 3309c37d8c42b2fd002b0d965dafc4be3b6d3e44
Author: Jim Meyering <meyering@HIDDEN>
Date:   Wed Oct 12 08:57:48 2016 -0700

    viper-tests.el: add a test for bug #24672

diff --git a/test/lisp/emulation/viper-tests.el
b/test/lisp/emulation/viper-tests.el
index 2c63b24..85d83aa 100644
--- a/test/lisp/emulation/viper-tests.el
+++ b/test/lisp/emulation/viper-tests.el
@@ -99,6 +99,19 @@ viper-test-undo-kmacro
       ]
      ))))

+(ert-deftest viper-test-insert-paren-on-cpp-continued-line()
+  "Test for bug #24672:
+Insert '#define z_b\', then change the 'z' to a parenthesis (open or closed)"
+  (should
+   (equal
+    "#define (_b\\\n"
+    (viper-test-undo-kmacro
+     [
+      ?i ?# ?d ?e ?f ?i ?n ?e ?  ?z ?_ ?b ?\\ escape
+         ?F ?z ?s ?\( escape
+         ])
+    )))
+
 (ert-deftest viper-test-undo-2 ()
   "Test for VI like undo behavior.

Is there some test set-up I can perform to make that test work like
what I outlined above?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24672; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Oct 2016 03:59:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 23:59:27 2016
Received: from localhost ([127.0.0.1]:52611 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1buAhT-0007JU-O2
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2016 23:59:27 -0400
Received: from eggs.gnu.org ([208.118.235.92]:41547)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1buAhR-0007JH-BI
 for submit <at> debbugs.gnu.org; Tue, 11 Oct 2016 23:59:25 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1buAhL-0001Im-AF
 for submit <at> debbugs.gnu.org; Tue, 11 Oct 2016 23:59:20 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:52606)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1buAhL-0001IU-75
 for submit <at> debbugs.gnu.org; Tue, 11 Oct 2016 23:59:19 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:60751)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1buAhI-0007Em-UE
 for bug-gnu-emacs@HIDDEN; Tue, 11 Oct 2016 23:59:17 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1buAhH-0001HS-So
 for bug-gnu-emacs@HIDDEN; Tue, 11 Oct 2016 23:59:16 -0400
Received: from mail-pa0-x235.google.com ([2607:f8b0:400e:c03::235]:33554)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1buAhH-0001Gt-MY
 for bug-gnu-emacs@HIDDEN; Tue, 11 Oct 2016 23:59:15 -0400
Received: by mail-pa0-x235.google.com with SMTP id vu5so24177299pab.0
 for <bug-gnu-emacs@HIDDEN>; Tue, 11 Oct 2016 20:59:15 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:from:to:subject:date:message-id:mime-version;
 bh=cb59g1sdJ1K533eqG/U02l3UVQjrEpS/gV4WCIXm+LI=;
 b=tanPJWy404WFIDmKCfoTqf1PKLa8ttQ9NjyoRvbqdqVVfvnNyfftnY6PCctdhQczTt
 Yi2o+0MZR1nHGlK4XTKA6qibHZbrOb+Z8BX8Kn/0ZNsMc060BnKMqIxOcehXPQ4EkUhv
 qroFGY7CahO9CUgbn/6YhGMM0sVAHkiLmZGvLSpLh2ZnQ4QcG+sKWNxD9eRXxpc1TAJu
 FMrS24Tmh3VfjGcBeGcjbxwAr4O7CzBt9nHDiXH2rHg9lSinBI79UzdbW7y7LP2duKiv
 oKevHlxZiRmodBPCTc2Um76J64NurzWWWGhJTnp37691wNNLBzHTFDbKtFUOu/saRFtZ
 BVRQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:sender:from:to:subject:date:message-id
 :mime-version;
 bh=cb59g1sdJ1K533eqG/U02l3UVQjrEpS/gV4WCIXm+LI=;
 b=XhHuzntB0GM0Dbe5DfMhH4/dUiAVtg2vg098iVqf3ImJmPGj1qPXwqt+C2Eo4XeinT
 rj0DORqhrpKTnF2kw1Du7/U0DgRfkmHec52Xd9ulXhi21ahVuDdIOiWdtnZAUcHUCGeN
 Xtj0DqyfSbHaAfzhLZF/NN/MHVGYKDEMfpZU9J3BGM+uC6/AKU5UOEBycPtRaUSrptDi
 ipEluqQ6KELh6FIkXVfLwZtJ2mMrxRiimN0A/sqSWv9i4KF9k7lGKpu7EgSaYE9pzHDk
 q+jT80igzUDhTl8sOdS296rGHiXQyVRiNHmPKZN8JYN7OSSul6KNziox2SydOtuwkkmU
 l/EQ==
X-Gm-Message-State: AA6/9RlJgVouqqKu3p19v3klxBmGUQlxhBor0r5d3kzlal72bzGwL9/nNtX/UkSW8SAuZg==
X-Received: by 10.66.158.200 with SMTP id ww8mr12137175pab.116.1476244754313; 
 Tue, 11 Oct 2016 20:59:14 -0700 (PDT)
Received: from jm.local ([2620:10d:c090:180::1:34d4])
 by smtp.gmail.com with ESMTPSA id e1sm7759698pap.11.2016.10.11.20.59.12
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Tue, 11 Oct 2016 20:59:13 -0700 (PDT)
From: Jim Meyering <jim@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 26.0.50; viper-mode + c-mode: "ce" fails in cpp-continued stmt
Date: Tue, 11 Oct 2016 20:59:05 -0700
Message-ID: <lubpf3fuo2tdyu.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

This is with an emacs binary I built from "master" yesterday.

Reproduce with this:

  printf '%s\n' '#define abcde \\' x > k.c; emacs -q -f viper-mode k.c

Then, hit "n" at the viperize prompt and you'll see this
on the first line:

  #define abcde \

Hit "W" to move the cursor to the "a". Then type "ce(" to
change the 5-byte "abcde" to a "(".  I was surprised to see
the "abcde" still there, and an additional backslash appended:

  #define (abcde \                                \

I expected to see this:

  #define ( \

In GNU Emacs 26.0.50.1 (x86_64-unknown-linux-gnu)
 of 2016-10-10 built on hx.meyering.net
 Repository revision: 8b1be820ce02379c9ebd124703e04eee65779662

Configured using:
 'configure --prefix=/p/p/emacs-2016-10-10.08h35 --without-gpm
  --without-x --with-x-toolkit=no --with-png=no --with-jpeg=no
   --with-sound=no'




Acknowledgement sent to Jim Meyering <jim@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#24672; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 26 Oct 2016 15:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.